2017-03-30  Phil Thompson  <phil@riverbankcomputing.com>

	* NEWS:
	Released as v4.19.2.
	[1df924860f57] [4.19.2] <4.19-maint>

2017-03-23  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/siplib.c.in:
	Remove an unnecessary comment.
	[1f31effbc614] <4.19-maint>

2017-03-03  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/siplib.c.in:
	Fixed a crash when a user defined class uses sip.wrappertype as it's
	meta-type but is not derived from sip.simplewrapper.
	[f5bab1986fbb] <4.19-maint>

2017-02-15  Phil Thompson  <phil@riverbankcomputing.com>

	* .hgtags:
	Added tag 4.19.1 for changeset ee5ea590d186
	[f45eb310f129] <4.19-maint>

	* NEWS:
	Released as v4.19.1.
	[ee5ea590d186] [4.19.1] <4.19-maint>

2017-02-13  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c:
	Fixed another regression in deprecated code.
	[556ca44cc535] <4.19-maint>

	* sipgen/gencode.c:
	Fixed some deprecated macros.
	[23a8ef68306d] <4.19-maint>

2017-02-08  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/siplib.c.in:
	Fixed a typo in the implementation of sipEnableGC().
	[c15936fc6007] <4.19-maint>

2017-02-05  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/siplib.c.in:
	Fixed a doesn't-work-with-old-c-compilers bug.
	[5775566848d1] <4.19-maint>

2017-02-02  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/transform.c:
	Fixed a regression in the generation of names of protected methods
	in classes imported from other modules.
	[948e06cb1921] <4.19-maint>

2017-02-01  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/metasrc/parser.y, sipgen/sip.h.in, sipgen/transform.c:
	Fixed a regression in determining when a shadow class should be
	generated.
	[71a8ee38b2c6] <4.19-maint>

2017-01-31  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/sip.h.in.in:
	Updated the ABI version number.
	[6b23496bd532] <4.19-maint>

	* sphinx/annotations.rst:
	Added a clarification to the /Abstract/ class annotation.
	[adb03184b044] <4.19-maint>

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in,
	sphinx/c_api.rst:
	Added sipEnableGC() to the public API.
	[03b120e8fe2f] <4.19-maint>

2017-01-29  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/metasrc/parser.y:
	Fixed a couple of missing types.
	[9737461081da] <4.19-maint>

2017-01-23  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c:
	More fixes for /NoTypeName/ applied to class templates.
	[8a45855e0d70] <4.19-maint>

2017-01-22  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, sipgen/metasrc/parser.y, sipgen/sip.h.in:
	The /NoTypeName/ typedef annotation now affects classes
	instantiation from class templates.
	[30d9a5a61ed2] <4.19-maint>

2017-01-21  Phil Thompson  <phil@riverbankcomputing.com>

	* NEWS, sipgen/gencode.c, sipgen/metasrc/lexer.l,
	sipgen/metasrc/parser.y, sipgen/sip.h.in, sphinx/directives.rst:
	Added the %PreMethodCode implementation from Robin Dunn.
	[08d77fb135a2] <4.19-maint>

	* sipgen/metasrc/parser.y:
	Properly fix the template super-class regression.
	[3b674fc274d5] <4.19-maint>

	* sipgen/metasrc/parser.y:
	Backed out changeset b94757bc5637 It fixes the bug but breaks
	everything else.
	[f39e23bcd25b] <4.19-maint>

	* sipgen/metasrc/parser.y:
	Fixed a regression in the handling of template arguments specifying
	super-classes.
	[b94757bc5637] <4.19-maint>

2017-01-20  Phil Thompson  <phil@riverbankcomputing.com>

	* README, build.py:
	Fixed the build.py script so that it does a complete preparation.
	[85539feb92ea] <4.19-maint>

2017-01-19  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/siplib.c.in:
	Fixed sipGetBufferInfo().
	[1de5c188f98d] <4.19-maint>

2017-01-10  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, sipgen/main.c, sipgen/transform.c,
	siplib/siplib.c.in, sphinx/command_line.rst:
	Added the -D command line option so that the generated code is aware
	of Python debug builds.
	[2a21ceefdf2a] <4.19-maint>

2017-01-09  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/siplib.c.in:
	Hopefully a better implementation of changeset dc06058c99dd.
	[4c135d33a5cf] <4.19-maint>

	* siplib/siplib.c.in:
	Backed out changeset dc06058c99dd The change is too drastic.
	[d9e95528015e] <4.19-maint>

2017-01-07  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/transform.c:
	Fixed a regression in the ordering of the generated types table for
	a module.
	[06237437b446] <4.19-maint>

2016-12-25  Phil Thompson  <phil@riverbankcomputing.com>

	* .hgtags:
	Added tag 4.19 for changeset 0a4ee5a5511f
	[245c1ac3c34e]

	* NEWS:
	Released as v4.19.
	[0a4ee5a5511f] [4.19]

2016-12-17  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/transform.c:
	Fixed a problem importing the required types for protected methods
	without the public/protected hack.
	[ccf3d8f3cc59]

2016-12-14  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/sip.h.in.in, siplib/siplib.c.in, sphinx/python_api.rst:
	Implemented sip.assign() to invoke the C++ assignment operator.
	[4324a0bc03a4]

2016-11-27  Phil Thompson  <phil@riverbankcomputing.com>

	* configure.py.in, sphinx/installation.rst:
	Added the --no-stubs and --stubsdir options to configure.py to be
	consistent with other configuration scripts.
	[70e0d9d09265]

2016-11-22  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/transform.c:
	Fixed the incomplete tidy-up.
	[69aaa13a1883]

2016-11-21  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/transform.c:
	Fix a warning message.
	[5d7b73925360]

	* sipgen/gencode.c, sipgen/sip.h.in, sipgen/transform.c:
	Reverted to pre-4.18 handling of the generated cast function. There
	are cases where a C++ derived class does not have the same address
	as its single base class.
	[8e9e02f1bea0]

2016-11-11  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/metasrc/parser.y:
	Fixed a regression (related to scoped names) that meant that header
	code for template arguments wasn't being included.
	[04796a24e981]

2016-10-28  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c:
	iHandwritten code to be included in the sipAPI*.h file is now placed
	at the end so that it can make use of the generated macros and
	types.
	[ed446493da18]

2016-10-26  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/siplib.c.in:
	Fixed some compiler warnings when building for Python v2.
	[264793ee3fb0]

2016-10-25  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/transform.c:
	Fixed a regression in the handling of abstratc classes.
	[ce1042e83d1a]

	* sipgen/gencode.c, sipgen/transform.c:
	More namespace related fixes.
	[73d456c2f5cc]

2016-10-18  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, sipgen/metasrc/parser.y, sipgen/sip.h.in,
	sipgen/transform.c, siplib/siplib.c.in:
	Implemented 'final' support. More fixes for the handling of scopes.
	[1d0d5c659b92]

2016-10-17  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/metasrc/lexer.l, sipgen/metasrc/parser.y, sipgen/sip.h.in,
	sphinx/specification_files.rst:
	Added parser support for the 'final' keyword.
	[373d57302d56]

2016-10-16  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, sipgen/metasrc/parser.y, sipgen/transform.c:
	Refactored the support for scopes so that types hav a leading '::'.
	[1f498dfe2888]

2016-10-09  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, sipgen/metasrc/parser.y, sipgen/sip.h.in,
	sipgen/transform.c:
	Fixed the generation of the scope of an operator moved from a
	namespace to a class.
	[f697ee13a3aa]

2016-10-06  Phil Thompson  <phil@riverbankcomputing.com>

	* sphinx/directives.rst:
	Documented the %HideNamespace directive.
	[b45a86055567]

	* sipgen/gencode.c, sipgen/metasrc/lexer.l, sipgen/metasrc/parser.y,
	sipgen/sip.h.in, sipgen/transform.c:
	Implemented the %HideNamespace directive.
	[6b1f471385df]

2016-10-05  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c:
	Make sure the underlying types are generated in tuple builders.
	[0507dfae0588]

	* sipgen/gencode.c:
	Virtual handlers use typedef names like all the rest of the
	generated code.
	[c732f0460bc3]

2016-10-04  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/transform.c:
	Refactored the name lookup code.
	[8bd669cf535f]

2016-09-29  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c:
	Variable getters/setters now only keep a hidden reference for C
	character strings.
	[6ec87337d5e2]

	* sipgen/gencode.c:
	Fixed a bad indentation in the generated code.
	[cb1d8e948a2b]

2016-09-25  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, sipgen/metasrc/parser.y, sipgen/sip.h.in,
	sipgen/transform.c, siplib/qtlib.c, siplib/sip.h.in.in,
	siplib/siplib.c.in, sphinx/using.rst:
	Removed anll code generator support for PyQt3.
	[a9cc0cc567aa]

2016-09-24  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/transform.c:
	A class that sub-classes an abstract class and doesn't provide an
	implementation of an abstract method is itself abstract.
	[472469f1d7ad]

	* sipgen/gencode.c, sipgen/metasrc/parser.y, sipgen/sip.h.in,
	sipgen/transform.c:
	Fixes for imported types that have multiple implementations.
	[dc02dc4430ec]

	* sipgen/transform.c, siplib/sip.h.in.in:
	Fixed the selection of a virtual handler.
	[d6c07e82a3d2]

2016-09-23  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/sip.h.in.in, siplib/sipint.h:
	Fixed some regressions when building with the limited API disabled.
	[8118a2156d11]

	* siplib/sip.h.in.in, siplib/sipint.h:
	Exposed some missing macros.
	[d12bb44a9d7d]

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in,
	sphinx/c_api.rst:
	Added sipGetUserObject() and sipSetUserObject() to the public API.
	[e0352cc51b67]

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/sipint.h,
	siplib/siplib.c.in:
	Added sipIsOwnedByPython() and sipIsDerivedClass() to the private
	API to remove more binary dependencies.
	[17ed5300e0dc]

	* sipgen/metasrc/parser.y, siplib/objmap.c, siplib/sip.h.in.in,
	siplib/siplib.c.in:
	Fix some warnings.
	[d0dcc6cd73b9]

	* sipgen/gencode.c, siplib/sip.h.in.in:
	Refactored how the plugin-specific generated tables are handled.
	[a0fcb2bc14ca]

2016-09-22  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/transform.c:
	Fixed the auto-generation of default copy ctors.
	[508f9dd396f9]

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in:
	Implemented the sipCallProcedureMethod() optimisation.
	[948be90a3f5e]

	* sipgen/transform.c, siplib/sip.h.in.in:
	Class based exceptions should now have their type structure
	included.
	[64ac366b669f]

	* siplib/sip.h.in.in, siplib/siplib.c.in:
	Reorganised the C API structure.
	[a08c7533a799]

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in:
	Completed the refactoring to eliminate binary dependencies.
	[fb3b72523947]

	* sipgen/gencode.c, sipgen/metasrc/parser.y, sipgen/sip.h.in,
	sipgen/transform.c, siplib/sip.h.in.in, siplib/siplib.c.in:
	Refactored the implementation of exceptions to eliminate the binary
	dependencies.
	[aeb733f23126]

	* sipgen/gencode.c, sipgen/metasrc/parser.y, sipgen/sip.h.in,
	sipgen/transform.c, siplib/sip.h.in.in, siplib/siplib.c.in:
	Refactored the handling of virtual error handlers to reduce binary
	dependencies.
	[b08f6f3325e8]

2016-09-21  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, sipgen/sip.h.in, sipgen/transform.c:
	Genearte the needed types table at the right time.
	[26331d156a87]

	* sipgen/gencode.c, sipgen/sip.h.in, sipgen/transform.c:
	Refactoring of the code that inspects a class for its visible
	virtuals.
	[082c756c263d]

2016-09-20  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/transform.c:
	Fixes for regressions using the type header files in the right
	place.
	[0b1a09bbde7a]

	* sipgen/gencode.c, sipgen/metasrc/parser.y, sipgen/sip.h.in,
	sipgen/transform.c, siplib/sip.h.in.in:
	Initial refactoring of virtual handlers.
	[d454a9b02d26]

2016-09-19  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, siplib/siplib.c.in:
	Generate the correct type names for template based types.
	[1f17d1688231]

	* sipgen/gencode.c, sipgen/metasrc/parser.y, sipgen/sip.h.in,
	sipgen/transform.c, siplib/sip.h.in.in, siplib/siplib.c.in,
	sphinx/c_api.rst, sphinx/incompatibilities.rst:
	Refactored the handling of generated type structures so that they
	are only referenced by name by an importing module rather than by an
	index into a table. This reduces the binary dependencies between
	modules.
	[667720dbc42d]

2016-09-15  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, sipgen/metasrc/parser.y, sipgen/sip.h.in,
	siplib/sip.h.in.in, siplib/siplib.c.in, sphinx/directives.rst:
	Removed the support for module version numbers.
	[685029cadb52]

2016-09-12  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/siplib.c.in:
	Fixed silly bugs in the previous change.
	[7df5236aa50f]

	* siplib/sip.h.in.in, siplib/siplib.c.in:
	Improved the implementation of sipGetBufferInfo().
	[7a606d0daf37]

2016-09-09  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/export.c, sipgen/type_hints.c:
	Fixed the type hint for unsigned const char *.
	[19f9b9eea667]

	* siplib/sip.h.in.in, siplib/siplib.c.in, sphinx/c_api.rst:
	Updated sipGetBufferInfo() to optionally check the type.
	sipGetBufferInfo() only supports 1-dimensional arrays.
	[985d7877b3a1]

2016-09-08  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/siplib.c.in:
	Further fixes for invoking the new type handler.
	[ecdcfc0f0558]

	* siplib/objmap.c, siplib/sip.h.in.in, siplib/siplib.c.in:
	Fixes for the invocation of the new user type handler.
	[a95c68d37f6e]

	* siplib/siplib.c.in:
	Fixed the invocation of the new user type handler.
	[d484574b76e9]

2016-09-07  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in,
	sphinx/c_api.rst:
	Added sipGetBufferInfo() and sipReleaseBufferInfo() to the public
	API.
	[c23d7cb8b06e]

2016-09-06  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/siplib.c.in, sphinx/c_api.rst:
	Documented the new Unicode-related functions.
	[c8408349d43c]

2016-09-05  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in:
	Added sipUnicodeNew(), sipUnicodeWrite() and sipUnicodeData() to the
	public API.
	[e05849602bef]

2016-08-30  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in,
	sphinx/c_api.rst:
	Added sipGetMethod(), sipFromMethod() and sipGetCFunction() ot the
	public API.
	[28f7daaa7542]

	* sipgen/gencode.c, sipgen/metasrc/parser.y, siplib/sip.h.in.in,
	siplib/siplib.c.in, sphinx/c_api.rst:
	Added sipCheckPluginForType() ot the public API.
	sipSetNewUserTypeHandler() now returns the old handler to allow
	chaining.
	[7e8e4447431b]

2016-08-29  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/descriptors.c, siplib/objmap.c, siplib/sip.h.in.in,
	siplib/siplib.c.in:
	Renamed some structure fields.
	[cb8478e5895d]

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in,
	sphinx/c_api.rst:
	Added sipPyTypeDict() to the public API.
	[7f25c1fe8296]

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in,
	sphinx/c_api.rst:
	Added sipGetFrame() to the public API.
	[a34c213208b2]

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in,
	sphinx/c_api.rst:
	Added sipIsUserType() to the public API.
	[d2477eb9265e]

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in,
	sphinx/c_api.rst:
	Added the data and time functions to the public API.
	[7739c16f94c9]

2016-08-28  Phil Thompson  <phil@riverbankcomputing.com>

	* sphinx/c_api.rst:
	Documented sipPyTypeName().
	[c7098cf08c3a]

	* sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in:
	Added sipPyTypeName() to the public API.
	[319512a38c50]

	* siplib/sip.h.in.in:
	Fixed the new macros.
	[c361a6924e82]

	* siplib/sip.h.in.in:
	Implemented additional portablity macros for the limited API.
	[120e916e8608]

	* .hgignore, sipgen/gencode.c, siplib/sip.h.in.in, siplib/siplib.c.in,
	sphinx/c_api.rst, sphinx/using.rst:
	Implemented sipSetNewUserTypeFunc() sipSetTypeUserData() and
	sipGetTypeUserData().
	[1f180cf4a42a]

2016-08-25  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/apiversions.c, siplib/array.c, siplib/array.h,
	siplib/descriptors.c, siplib/objmap.c, siplib/qtlib.c,
	siplib/sip.h.in.in, siplib/sipint.h, siplib/threads.c,
	siplib/voidptr.c, sphinx/c_api.rst, sphinx/directives.rst:
	Added the user field to the sipWrapperType structure as an
	alternative to defining a super-type of sipWrapperType (which isn't
	possible with the limited API). Bumped the major ABI version number.
	[5e9de8cde212]

2016-08-24  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, sipgen/metasrc/lexer.l, sipgen/metasrc/parser.y,
	sipgen/sip.h.in, siplib/sip.h.in.in, siplib/siplib.c.in,
	sphinx/directives.rst:
	Added the use_limited_api argument to the %Module directive. Changed
	the API of %BIGetBufferCode when using the limited API.
	[10d7121c07e3]

2016-08-23  Phil Thompson  <phil@riverbankcomputing.com>

	* rbproduct.py:
	Merged the 4.18-maint branch into the trunk.
	[d92384aa5baf]

	* sipgen/gencode.c:
	Fixed the handling of global unsigned constants.
	[a45bec408ec2] <4.18-maint>

	* sphinx/conf.py.in:
	Fixed the copyright notice in the docs.
	[17475357a153] <4.18-maint>

2016-08-08  Phil Thompson  <phil@riverbankcomputing.com>

	* README, build.py:
	Removed the old internal build system leaving the minimum needed to
	build from hg without the new build system.
	[dbbced5689a8] <4.18-maint>

2016-07-25  Phil Thompson  <phil@riverbankcomputing.com>

	* .hgtags:
	Added tag 4.18.1 for changeset 81021a5690ce
	[8f5b6c8fe5f1] <4.18-maint>

	* NEWS:
	Released as v4.18.1.
	[81021a5690ce] [4.18.1] <4.18-maint>

2016-07-22  Phil Thompson  <phil@riverbankcomputing.com>

	* Roadmap.rst:
	Updated the Roadmap.
	[1226013f2516] <4.18-maint>

	* NEWS:
	Updated the NEWS file.
	[26a4fd92bf59] <4.18-maint>

2016-07-03  Phil Thompson  <phil@riverbankcomputing.com>

	* siplib/objmap.c:
	Fixed a problem with stale aliases for objects created by C/C++.
	[b493c6f3e015] <4.18-maint>

2016-06-21  Phil Thompson  <phil@riverbankcomputing.com>

	* rb-product, rbproduct.py:
	Replaced the product plugin with a product file.
	[a10b0caa91a8] <4.18-maint>

2016-06-20  Phil Thompson  <phil@riverbankcomputing.com>

	* rbproduct.py:
	Product plugin changes for rb-tools API changes.
	[86f51ad3ac30] <4.18-maint>

	* rbproduct.py:
	Debugged the product plugin.
	[67a81861273c] <4.18-maint>

	* rbproduct.py:
	Added support for a minimal build and release build types.
	[8cc794662db5] <4.18-maint>

2016-06-18  Phil Thompson  <phil@riverbankcomputing.com>

	* rbproduct.py:
	Tewaks to the product plugin.
	[b2fd658f11cf] <4.18-maint>

2016-06-15  Phil Thompson  <phil@riverbankcomputing.com>

	* rbproduct.py:
	Debugged the support for rb-release.
	[38cdb78872f4] <4.18-maint>

2016-06-13  Phil Thompson  <phil@riverbankcomputing.com>

	* rbproduct.py:
	Updated the product plugin to support rb-release.
	[ecb166af3ad3] <4.18-maint>

2016-06-10  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c:
	Fixed a regression in the handling of a cast with a diamond
	hierachy.
	[91206af66161] <4.18-maint>

2016-06-02  Phil Thompson  <phil@riverbankcomputing.com>

	* rbproduct.py:
	Implemented the different build types.
	[15184d86e394] <4.18-maint>

	* rbproduct.py:
	Updates to the product plugin.
	[23ca59449373] <4.18-maint>

2016-06-01  Phil Thompson  <phil@riverbankcomputing.com>

	* rbproduct.py:
	Updated the product plugin to simplify the class hierachy.
	[a977c7f870f7] <4.18-maint>

	* .hgignore, rbproduct.py:
	The product plugin will now do a default build.
	[8c433398f573] <4.18-maint>

2016-05-09  Phil Thompson  <phil@riverbankcomputing.com>

	* rbproduct.py:
	Updated the product plugin for the latest rbtools changes.
	[a4a0a84984dc] <4.18-maint>

2016-05-05  Phil Thompson  <phil@riverbankcomputing.com>

	* configure.py.in:
	Fixed a bug in out-of-source builds.
	[f9602fd24f17] <4.18-maint>

2016-04-22  Phil Thompson  <phil@riverbankcomputing.com>

	* METADATA.in:
	Updated the meta-data to say that 64-bit Linux wheels are available
	at PyPI.
	[5602445cb458] <4.18-maint>

2016-04-13  Phil Thompson  <phil@riverbankcomputing.com>

	* .hgtags:
	Added tag 4.18 for changeset b51768a1749e
	[1da474e6ccc1]

	* NEWS, sphinx/specification_files.rst:
	Released as v4.18.
	[b51768a1749e] [4.18]

	* METADATA.in, sipgen/export.c, sipgen/type_hints.c:
	Fixed the type hints for arrays.
	[02a712634ce1]

2016-04-09  Phil Thompson  <phil@riverbankcomputing.com>

	* METADATA.in:
	Updated the description in the meta-data.
	[d9eb656132f3]

2016-04-08  Phil Thompson  <phil@riverbankcomputing.com>

	* METADATA.in:
	Further tweak to METADATA.in.
	[9acfb4baa44c]

	* METADATA.in:
	Use v1.1 meta-data rather than v2.0.
	[8d9645471343]

	* METADATA.in:
	Fixed a typo.
	[4a9ee34e65c3]

	* METADATA.in, rbproduct.py:
	Added the METADATA.in file.
	[39106871989b]

2016-04-05  Phil Thompson  <phil@riverbankcomputing.com>

	* rbproduct.py:
	Updated the product plugin.
	[e42e999389f9]

	* rbproduct.py:
	Added the rbtools product plugin.
	[b9ba57967915]

2016-03-30  Phil Thompson  <phil@riverbankcomputing.com>

	* sphinx/incompatibilities.rst:
	Fixed a Sphinx warning message.
	[ae966103325c]

	* sipgen/main.c, sipgen/sip.h.in, sipgen/transform.c:
	Fixed the use of SIP_NORETURN.
	[b3a916e0bc78]

2016-03-25  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/export.c:
	Fixed a regression in the exporting of the XML API files.
	[c7714bbbdae7]

	* build.py, sphinx/build_system.rst, sphinx/c_api.rst,
	sphinx/python_api.rst:
	Adopt the new standards for naming development versions.
	[72140f544ef1]

	* sphinx/annotations.rst:
	Fixed a bug in the documentation.
	[9e4ee12928cd]

	* .hgignore:
	Added the .hgignore file.
	[e1d2556ce4a2]

2016-03-04  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c:
	__long__ gets translated to __int__ for Python v3.
	[a4f8a7810cc3]

2016-03-01  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/type_hints.c, sphinx/annotations.rst:
	Type hints are ignored if an argument is constrained.
	[f041cf891a29]

	* sipgen/type_hints.c:
	Implement the flattening of Unions in type hints.
	[ff5f0d0251e0]

2016-02-29  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/sip.h.in, sipgen/type_hints.c:
	Reimplemented the type hint parser so it can handle recursive
	definitions properly.
	[506e30d92b51]

2016-02-27  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/type_hints.c:
	Fixed type hints for enums in mapped types.
	[efb04ab24462]

	* sipgen/type_hints.c:
	Fixed type hints for the return values of functions.
	[b5c392c71f78]

	* sipgen/type_hints.c:
	Added Iterable to the list of known typing module objects.
	[a1d1a573a304]

2016-02-26  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/sip.h.in, sipgen/type_hints.c:
	Fixed the handling of recursively defined type hints.
	[b5abe12b4968]

2016-02-25  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/sip.h.in, sipgen/type_hints.c:
	The typing module is now imported as a whole rather than individual
	objects.
	[ac67b3f0bd95]

2016-02-24  Phil Thompson  <phil@riverbankcomputing.com>

	* sip.pyi:
	Fixed the Buffer type hint.
	[78a799aec114]

	* sipgen/type_hints.c:
	Don't generate type hints for the sequence concat and repeat slots
	(and the inplace versions).
	[a5ae3982ff5f]

	* sipgen/metasrc/parser.y, sphinx/directives.rst:
	Exported type hint code is no longer included in the module that
	defines it.
	[442b3ed07ae6]

	* sipgen/type_hints.c:
	Exclude external classes when looking up a class.
	[61fe4c76a394]

	* sipgen/transform.c, sipgen/type_hints.c:
	Fixed type hints and docstrings for const template arguments.
	[679c13adda6a]

	* sipgen/metasrc/parser.y, sipgen/sip.h.in, sipgen/type_hints.c,
	sphinx/directives.rst:
	%TypeHintCode can now be used in a class.
	[053c7351dba2]

2016-02-19  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/type_hints.c:
	Don't generate type hints for slots that can return
	Py_NotImplemented. Make sure callables generate a valid (but vague)
	type hint.
	[883918a8dc36]

2016-02-18  Phil Thompson  <phil@riverbankcomputing.com>

	* sip.pyi, sipgen/type_hints.c:
	Tweaks to the type hint support.
	[785978d8f7e3]

2016-02-16  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/metasrc/parser.y, sipgen/sip.h.in, sipgen/transform.c,
	sipgen/type_hints.c, sphinx/annotations.rst:
	Added the /TypeHint/, /TypeHintOut/ and /TypeHintValue/ class
	annotations.
	[4f5dc2c51d06]

	* sipgen/type_hints.c:
	Moved the old-style signal/slot type hints to PyQt4.
	[4689a40f7e7d]

2016-02-15  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/metasrc/parser.y, sipgen/sip.h.in, sipgen/transform.c,
	sphinx/annotations.rst:
	Implemented /TypeHintValue/ as a mapped type annotation.
	[2418e7f7760d]

	* build.py:
	Make sure sip.pyi is included in the source package.
	[1eabde271e53]

2016-02-11  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/gencode.c, sipgen/metasrc/lexer.l, sipgen/metasrc/parser.y,
	sipgen/transform.c, siplib/siplib.c.in:
	Eliminate a few compiler warnings.
	[e864a0451a4a]

2016-02-10  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/type_hints.c:
	More fixes for Optional handling.
	[365d31de81fd]

	* sipgen/type_hints.c:
	Use Optional properly.
	[ab7d66d1ea0d]

2016-02-09  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/type_hints.c:
	PY_TYPE and PY_SLICE aren't actually needed.
	[9778770c65a5]

2016-02-08  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/type_hints.c:
	Fixed the translation of Any to object in docstrings.
	[7571d96c1f79]

	* sipgen/export.c, sipgen/gencode.c, sipgen/sip.h.in,
	sipgen/type_hints.c:
	Docstrings now use a format based on type hints.
	[9de9b0470aa6]

2016-02-05  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/transform.c:
	Don't complain about a lack of %SetCode when /NoSetter/ is
	specified.
	[cf4db5eb171a]

	* sipgen/metasrc/parser.y:
	Fixed some typos in error messages.
	[82a34911686f]

	* sipgen/metasrc/lexer.l, sipgen/metasrc/parser.y,
	sphinx/directives.rst:
	Renamed %ModuleTypeHintCode to %TypeHintCode.
	[73b214c14dde]

	* sipgen/type_hints.c, sphinx/annotations.rst:
	Documented the /NoTypeHint/ annotations.
	[26e59a86ca45]

	* sipgen/metasrc/parser.y, sipgen/sip.h.in, sipgen/transform.c,
	sipgen/type_hints.c:
	Implemented the /NoTypeHint/ annotation. Fixed a bug to make sure
	type header code is included before enum slot code needs it.
	[1943d4866c73]

	* sipgen/metasrc/parser.y, sipgen/type_hints.c:
	More flexible handling of ellipsis when /NoArgParser/ is specified.
	[7097a0008042]

	* sipgen/metasrc/parser.y, sipgen/sip.h.in, sipgen/type_hints.c:
	Protect against (possible) recursion when handling type hints for
	mapped types.
	[9402857f5eb6]

	* sipgen/metasrc/parser.y, sipgen/sip.h.in, sipgen/transform.c,
	sipgen/type_hints.c:
	Fixed class /TypeHintIn/ when used with a template.
	[3a914d9789e0]

2016-02-04  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/metasrc/parser.y, sipgen/sip.h.in, sipgen/type_hints.c,
	sphinx/annotations.rst:
	Added /TypeHintIn/ as a class annotation.
	[92d3d32ebf64]

2016-02-03  Phil Thompson  <phil@riverbankcomputing.com>

	* sipgen/export.c, sipgen/metasrc/parser.y, sipgen/sip.h.in,
	sipgen/transform.c, sipgen/type_hints.c:
	Completed the implementation of /TypeHintIn/ and /TypeHintOut/.
	[70e9172c61b7]

	* sipgen/export.c, sipgen/metasrc/parser.y, sipgen/sip.h.in:
	Implement /TypeHintValue/ as a synonym for /DocValue/ for the
	moment.
	[df8230d91f9f]

	* sipgen/metasrc/parser.y, sphinx/annotations.rst:
	Adde the stubs of the /TypeHintIn/, /TypeHintOut/ and
	/TypeHintValue/ annotations.
	[aeb5d848b98a]
